#include<bits/stdc++.h>
using namespace std;

const long long MOD = 998244353;
long long fact[1000];
long long inv[1000];
long long haha[1001][1001];

long long power(long long a, long long b) {
    if(b == 0) {
        return 1;
    }
    long long ans = power(a,b/2);
    ans*=ans;
    ans%=MOD;
    if(b%2) {
        ans*=a;
        ans%=MOD;
    }
    return ans;
}

long long calc(long long n, long long k) {
    if(k < 0 || k > n || n < 0) {
        return 0;
    }
    return (((fact[n]*inv[n-k])%MOD)*inv[k])%MOD;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    long long n,m,k,ans = 0,c;
    cin >> n >> m >> k;
    fact[0] = 1;
    inv[0] = 1;
    for(long long i = 1; i < 1000; i++) {
        fact[i] = (fact[i-1]*i)%MOD;
        inv[i] = (inv[i-1]*power(i,MOD-2))%MOD;
    }
    for(int i = 0; i <= m; i++) {
        haha[0][i] = 1;
    }
    for(int i = 1; i <= n; i++) {
        haha[i][0] = 0;
        for(int j = 1; j <= m; j++) {
            haha[i][j] = 0;
            for(int y = 0; y <= k; y++) {
                if(i-y >= 0) {
                    haha[i][j]+=calc(i,y)*haha[i-y][j-1];
                    haha[i][j]%=MOD;
                }
            }
        }
    }
    cout << haha[n][m];
    return 0;
}
