#include <iostream>

using namespace std;

const int maxn = 30;
const long long mod = 998244353;

int n, m, k;
int bf[maxn];

int ans = 0;

int cnt[maxn];

void f(int idx)
{
    if (idx == n + 1)
    {
        ans++;

        if (ans >= mod)
        {
            ans -= mod;
        }

        return;
    }

    bool flag = true;

    for (int i = 1; i <= m; ++i)
    {
        if (cnt[i] + (n - idx + 1) > k)
        {
            flag = false;
            break;
        }
    }

    if (flag == true)
    {
        long long pw = 1;

        for (int i = idx; i <= n; ++i)
        {
            pw *= (1LL * m);
            pw %= mod;
        }

        ans += pw;
        ans %= mod;

        return;
    }

    for (int i = 1; i <= m; ++i)
    {
        if (cnt[i] + 1 <= k)
        {
            bf[idx] = i;
            cnt[i]++;

            f(idx + 1);
            cnt[i]--;
        }
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m >> k;

    f(1);

    cout << ans << endl;

    return 0;
}
