#include<bits/stdc++.h>
using namespace std;

#define endl "\n"

const int MAX_N = 1e7 + 10;

/*
long long toDecimal(string& s){
    long long ans = 0;
    for(int i = s.size() - 1; i >= 0; i--){
        ans += (s[i] - '0') * pow(2, s.size() - 1 - i);
    }
    return ans;
}
*/

long long dp[MAX_N];

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    long long n;
    cin>>n;
    if(n >= MAX_N) return 0;

    long long current = 1;
    long long maxFound = 1;
    for(long long i = 0; current <= n; i ++){
        dp[current] = 1;
        for(long long j = maxFound; j >= 1; j--){
            if(j == current) continue;
            if(dp[j] == 0) continue;
            if(dp[j + current] == 0 || dp[j + current] > dp[current] + 1){
                dp[j + current] = dp[current] + 1;
                maxFound = max(maxFound, j + current);
            }
        }
        if(i % 2 == 0) current *= 2;
        if(i % 2 == 1) current = current * 2 + 1;
        //cout<<current<<endl;
    }

    //for(long long i = 0; i < maxFound; i++){
    //    cout<<"dp["<<i<<"] = "<<dp[i]<<endl;
    //}

    if(dp[n] == 0){
        cout<<-1<<endl;
        return 0;
    }

    cout<<dp[n]<<endl;

    return 0;
}


/*
1
2
5
10
21
42
85
170
341
682
1365
2730
5461
10922
21845
43690
87381
174762
349525
699050
*/
