#include<bits/stdc++.h>
#define endl "\n"
#define MOD 998244353
using namespace std;
long long n,m,k;
int factors[310];
long long fastPow(long long a,long long b){//a^b
    long long x=a;
    long long ans=1;
    while(b!=0){
        if(b%2==1){
            ans*=x;
            ans%=MOD;
        }
        x*=x;
        x%=MOD;
        b/=2;
    }
    return ans;
}
vector<int> factor(long long n){
    vector<int> ans;
    for(int i=2;i*i<=n;i++){
        while(n%i==0){
            ans.push_back(i);
            n/=i;
        }
    }
    if(n!=1) ans.push_back(n);
    return ans;
}
long long comb(long long a,long long b){//a!/b!/(a-b)!
    for(int i=0;i<=300;i++){
        factors[i]=0;
    }
    for(int i=1;i<=a;i++){
        vector<int> v=factor(i);
        for(int j=0;j<v.size();j++){
            factors[v[j]]++;
        }
    }
    for(int i=1;i<=b;i++){
        vector<int> v=factor(i);
        for(int j=0;j<v.size();j++){
            factors[v[j]]--;
        }
    }
    for(int i=1;i<=a-b;i++){
        vector<int> v=factor(i);
        for(int j=0;j<v.size();j++){
            factors[v[j]]--;
        }
    }
    int ans=1;
    for(int i=2;i<=300;i++){
        ans*=fastPow(i,factors[i]);
        ans%=MOD;
    }
    return ans;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin>>n>>m>>k;
    int ans=fastPow(m,n);
    for(int i=k+1;i<=n;i++){
        ans-=m*comb(n,i)*fastPow(m-1,n-i);
    }
    cout<<ans;
    return 0;
}

