#include<bits/stdc++.h>
#define endl "\n"
#define MOD 998244353
using namespace std;
long long factors[310];
long long fastPow(long long a,long long b){//a^b
    long long x=a;
    long long ans=1;
    while(b!=0){
        if(b%2==1){
            ans*=x;
            ans%=MOD;
        }
        x*=x;
        x%=MOD;
        b/=2;
    }
    return ans;
}
vector<long long> factor(long long n){
    vector<long long> ans;
    for(long long i=2;i*i<=n;i++){
        while(n%i==0){
            ans.push_back(i);
            n/=i;
        }
    }
    if(n!=1) ans.push_back(n);
    return ans;
}
long long comb(long long a,long long b){//a!/b!/(a-b)!
    for(long long i=0;i<=300;i++){
        factors[i]=0;
    }
    for(long long i=1;i<=a;i++){
        vector<long long> v=factor(i);
        for(long long j=0;j<v.size();j++){
            factors[v[j]]++;
        }
    }
    for(long long i=1;i<=b;i++){
        vector<long long> v=factor(i);
        for(long long j=0;j<v.size();j++){
            factors[v[j]]--;
        }
    }
    for(long long i=1;i<=a-b;i++){
        vector<long long> v=factor(i);
        for(long long j=0;j<v.size();j++){
            factors[v[j]]--;
        }
    }
    long long ans=1;
    for(long long i=2;i<=300;i++){
        ans*=fastPow(i,factors[i]);
        //cout<<i<<" "<<factors[i]<<"   "<<fastPow(i,factors[i])<<" "<<ans<<endl;
        ans%=MOD;
    }
    return ans;
}
long long dp(long long n,long long m,long long k){
    long long ans=fastPow(m,n);
    //long long ans2=ans;
    for(long long i=k+1;i<=n;i++){
        long long curr=(m*comb(n,i)*dp(n-i,m-1,k))%MOD;
        //long long curr2=(m*comb(n,i)*fastPow(m-1,n-i))%MOD;
        ans-=curr;
        //ans2-=curr2;
        if(ans<0) ans+=MOD;
        //if(ans2<0) ans2+=MOD;
    }
    //cout<<n<<" "<<m<<" "<<k<<"   "<<ans<<" "<<ans2<<endl;
    return ans;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    long long n,m,k;
    cin>>n>>m>>k;
    cout<<dp(n,m,k);
    return 0;
}

