#include <bits/stdc++.h>
using namespace std;

const int MAX_N=1e5+1, MAX_Q=1e5+1;
int N, Q;
long a[MAX_N], max_a=0, min_a=1e9;
int quest[MAX_N];
int ans[MAX_Q];
unordered_map<long, int> um;

long bs_b(const long& x)
{
    long l=0, r=max_a;
    long m=0;
    long ans=1e9;

    while(l<=r)
    {
        m=(l+r)/2;

        if(um[m]==1)
        {
            ///cout << m << " " << x << '\n';
            if(m>=x)
            {
                ans=min(m-x, ans);
                r=m-1;
            }
            else
            {
                ans=min(x-m, ans);
                l=m+1;
            }
        }
        else
        {
            if(m<max_a)
            {
                l=m+1;
            }
            else
            {
                r=m-1;
            }
        }
    }

    return ans;
}

long bs_s(const long& x)
{
    int l=0, r=max_a;
    int m=0;
    int ans=1e9;

    while(l<=r)
    {
        m=(l+r)/2;

        if(um[m]==1)
        {
            ///cout << m << " " << x << " " << abs(m-x) << '\n';
            if(m>=x)
            {
                ans=min(m-x, ans);
                ///cout << m-x << '\n';
                r=m-1;
            }
            else
            {
                ans=min(x-m, ans);
                ///cout << x-m << '\n';
                l=m+1;
            }
        }
        else
        {
            if(m>min_a)
            {
                r=m-1;
            }
            else
            {
                l=m+1;
            }
        }
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N >> Q;

    for(int i=0; i<N; i++)
    {
        cin >> a[i];
    }

    for(int i=0; i<Q; i++)
    {
        long j;
        cin >> j;
        quest[j-1]=i+1;
    }

    long mindiff=1e9;

    for(int i=0; i<N; i++)
    {
        if(i>0)
        {
            long b=bs_b(a[i]);
            long s=bs_s(a[i]);

            ///cout << b << "->" << s << '\n';
            mindiff=min(mindiff, min(b, s));
        }

        max_a=max(max_a, a[i]);
        min_a=min(min_a, a[i]);
        um[a[i]]=1;

        if(quest[i]!=0)
        {
            ans[quest[i]-1]=mindiff;
        }
    }

    for(int i=0; i<Q; i++)
    {
        cout << ans[i] << " ";
    }
    return 0;
}
