#include<iostream>
#include<math.h>
using namespace std;
long long N, M, K;
const long long mod = 998244353;
long long fact(long long a){
    long long sum = 1;
    for(long long i=1; i<=a; i++){
        sum *= i;
        sum %= mod;
    }
    return sum;
}
long long stepenModul(long long a, long long n, long long m){
    long long otg = 1;
    for(long long i=0; i<n; i++){
        otg *= a;
        otg = otg%m;
    }
    return otg;
}
long long red(long long vs, long long vuz, long long pov){
    if(vs==pov){
        return vuz;
    }
    long long sum = 0;
    for(long long i=1; i<=vs-pov; i++){
        sum += (red(vs-pov, vuz-1, i)*fact(vs)/fact(pov)/fact(vs-pov)*fact(vs-pov)/fact(i)/fact(vs-pov-i))%mod;
    }
    return (vuz*sum)%mod;
}
int main(){
    cin>>N>>M>>K;
    long long otg = stepenModul(M, N, mod);
    ///cout<<otg<<'\n';
    for(long long i = N-1; i>=K; i--){
        otg -= red(N, M, i+1);
    }
    cout<<otg%mod;
    return 0;
}
