#include <iostream>
#include <queue>

using namespace std;

long long Nums[1000000];
long long MinDiff[1000000];

long long AbsDiff(long long a, long long b)
{
    if (a >= b)
    {
        return a - b;
    }
    return b - a;
}

int main()
{
    long long N, Q, T;
    cin >> N >> Q;

    for (int i = 0; i < N; i++)
    {
        cin >> Nums[i];
        MinDiff[i] = 1000000000000000000;
    }

    MinDiff[1] = abs(Nums[0] - Nums[1]);

    for (int i = 2; i < N; i++)
    {
        for (int j = 0; j < i; j++)
        {
            MinDiff[i] = min(MinDiff[i], AbsDiff(Nums[i], Nums[j]));
            ///cout << i << " " << j << " - " << MinDiff[i] << endl;
        }
    }

    for (int i = 0; i < Q; i++)
    {
        cin >> T;
        cout << MinDiff[T - 1] << " ";
    }
}
