#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll MOD = 998244353;
ll N, M, K;

unordered_map <ll, ll> map4e;
ll ans = 0;

ll fact(ll j)
{
    ll res = 1;

    while (j > 1)
    {
        res *= j;
        j--;
    }

    return res;
}

void solve(ll pos, ll num)
{
    if (pos >= N + 1)
    {
        return;
    }

    if (map4e[num] > K)
    {
        return;
    }

    if (pos == N)
    {
        ll add = 1;
        ll ost = N;

        for (auto c : map4e)
        {
            ll q = c.second;

            if (c.second == 0)
            {
                continue;
            }

            for (ll p = ost; p >= ost - q + 1; p--)
            {
                add *= p;
            }

            add /= fact(c.second);
            ost -= c.second;
        }

        ans += add;
        ans %= MOD;

        return;
    }

    for (ll q = num; q <= K; q++)
    {
        map4e[q]++;
        solve(pos + 1, q);
        map4e[q]--;
    }

    return;
}

int main()
{
    cin >> N >> M >> K;

    solve(0, 1);

    cout << ans << endl;

    return 0;
}
