#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

int d[500010];

int bin_search (int a, vector<int> num) {
    int s = num.size();

    int st = 0, en = s - 1;
    int m = (en + st) / 2;

    if (num[s - 1] <= a) {
        return s;
    }
    if (num[0] >= a) {
        return 0;
    }
    bool test = 0;

    while (st <= en) {
        m = (en + st) / 2;

        if (m == 0) {
            return 1;
        }
        if (m == s) {
            return s - 1;
        }

        if (num[m - 1] <= a && a <= num[m]) {
            return m;
        }

        if (num[m - 1] > a) { /// 1, 2, 3,   2  , 5
            en = m - 1;
        }

        if (num[m] < a) { /// 1, 2, 3,   100  , 5
            st = m + 1;
        }
    }
    return m;
}

void qEquals1EzSolution (vector<int> a, int n) {
    for (int i = 0; i < n; i++) {
        int temp;
        cin >> temp;
        a.push_back(temp);
    }
    int b, ans = 2000000000;
    cin >> b;
    sort(a.begin(), a.begin() + b);
    for (int i = 1; i < b; i++) {
        ans = min(ans, a[i] - a[i - 1]);
    }
    cout << ans;
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
//    cout.tie(0);

    int n, q;
    cin >> n >> q;

    vector<int> num;

    if (q == 1) {
        qEquals1EzSolution(num, n);
        return 0;
    }
    for (int i = 0; i < n; i++) {
        int temp;
        cin >> temp;
        if (i == 0) {
            num.push_back(temp);
            d[1] = 2000000000;
        } else {
            int place = bin_search(temp, num);
            num.insert(num.begin() + place, temp);

            if (place == num.size() - 1) {
                d[i + 1] = min(d[i], num[place] - num[place - 1]);
                continue;
            }
            if (place == 0) {
                d[i + 1] = min(d[i], num[1] - num[0]);
                continue;
            }

            d[i + 1] = min(d[i], min(num[place] - num[place - 1], num[place + 1] - num[place]));
        }
    }

    for (int i = 0; i < q; i++) {
        int temp;
        cin >> temp;

        cout << d[temp] << " ";
    }
}
