#include <iostream>
#include <math.h>
#define ULL unsigned long long
using namespace std;

ULL toDec(string s)
{
    ULL n=0, sz=s.size(), p=sz-1;
    for (ULL i=0 ; i<sz ; i++)
    {
        n+= (s[i]-'0') * pow(2, p);
        p--;
    }
    return n;
}

string toBin(ULL n)
{
    string s;
    int p=0;
    ULL ncopy=n;
    while (ncopy>1)
    {
        ncopy/=2;
        p++;
    }
    for ( ; p>=0 ; p--)
    {
        if (pow(2, p) <= n)
        {
            s+='1';
            n-=pow(2, p);
        }
        else s+='0';
    }
    return s;
}

string convert(ULL sz)
{
    string b;
    bool p=1;
    for ( ; b.size() != sz ; p = (p!=1))
    {
        b+=p+'0';
    }
    return b;
}

int main()
{
    string a, b;
    ULL an, bn, br=0;
    cin >> an;
    for (a=toBin(an) ; a!="10" && a!="1" ; br++)
    {
        b=convert(a.size());
        if (b==a) break;
        an=toDec(a);
        bn=toDec(b);
        if (bn>an)
        {
            b.pop_back();
            bn=toDec(b);
        }
        //cout << "a= " << a << " b= " << b << " an= " << an << " bn= " << bn << endl;
        if (an-bn == bn)
        {
            cout << -1;
            return 0;
        }
        a=toBin(an-bn);
    }
    cout << br+1;
    return 0;
}
