#include <bits/stdc++.h>

using namespace std;

const long long mod = 998244353;
const int maxn = 305;
const int maxm = 305;

int n,m,k;
long long dp[maxm][maxm];
long long pasc[maxn][maxn];
long long pref[maxn][maxn];
long long ans[maxn];

void pre()
{
    for(int i=0;i<=300;i++)
    {
        pasc[i][0] = 1;
        pasc[i][i] = 1;
        for(int j=1;j<i;j++)
        {
            pasc[i][j] = pasc[i-1][j] + pasc[i-1][j-1];
            pasc[i][j] %= mod;
        }
    }
}

void read()
{
    cin >> n >> m >> k;
    pre();
}

void solve()
{
    for(int i=0;i<=300;i++)
    {
        pref[0][i] = 1;
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            dp[j][0] = pref[i][j-1];
            ans[i] += dp[j][0];
            ans[i] %= mod;
            pref[i][j] += dp[j][0];
            pref[i][j] %= mod;
            for(int q=1;q<=min(i,k);q++)
            {
                dp[j][q] = pref[i-q][j-1] * pasc[i][q];
                //cout << i << " " << j << " " << q << endl;
                //cout << dp[i][j][q] << endl;
                dp[j][q] %= mod;
                ans[i] += dp[j][q];
                ans[i] %= mod;
                pref[i][j] += dp[j][q];
                pref[i][j] %= mod;
            }
        }
    }
    cout << pref[n][m] << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
