#include <iostream>
#include <vector>
#include <algorithm>
#define endl '\n'
using namespace std;
int n, q, m, a[100001];
void read()
{
    cin >> n >> q;
    for(int i = 1; i <= n; i++)cin >> a[i];
}
int dp[100001];
void fill_dp()
{
    dp[1] = 1000000001;
    for(int i = 2; i <= n; i++)
    {
        int diff;
        dp[i] = dp[i-1];
        for(int j = 1; j < i; j++)
        {
            diff = abs(a[j] - a[i]);
            if(diff < dp[i])dp[i] = diff;
        }
    }
}
void solve()
{
    for(int i = 1; i <= q; i++)
    {
        cin >> m;
        cout << dp[m] << " ";
    }
    cout << endl;
}
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    if(q == 1)
    {
        cin >> m;
        vector<int>v;
        for(int i = 1; i <= m; i++)
        {
            v.push_back(a[i]);
        }
        sort(v.begin(), v.end());
        int mindiff = 1000000001;
        for(int i = 1; i < m; i++)
        {
            if(v[i] - v[i-1] < mindiff)mindiff = v[i] - v[i-1];
        }
        cout << mindiff << endl;
        return 0;
    }
    fill_dp();
    solve();
    return 0;
}
