#include <iostream>
#include <math.h>
using namespace std;

long long pow_r(int u,int v) {
    long long r = 1ll;
    for (int i = 0; i < v; i++)
    {
        r *= (long long)u;
        if (r > 998244353ll)
        {
            r %= 998244353ll;
        }
    }
    return r;
}

int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    long long sub = pow_r(m, 2 * (n - k) - 1);
    if (sub == 1)
    {
        sub = 0;
    }
    cout << (pow_r(m, n) - sub) % 998244353ll;
}