#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<string, ll> psl;
string alternate(ll n){
    string s = "1";
    char last = true;
    for(ll i = 0; i < n; i++){
        last = !last;
        char c = ((char)last+'0');
        s += c;
    }
    return s;
}
ll mag(ll n){
    if(n == 0){ return 0; }
    else if(n > 0){ return 1; }
    else if(n < 0){ // Racheva:  :(
        return -1;
    }
}
ll cmp(string a, string b){
    ll ldif = a.length() - b.length();
    if(ldif != 0){return mag(ldif);}
    for(ll i = 0; i < a.length(); i++){
        ldif = a[i] - b[i];
        if(ldif != 0){return mag(ldif);}
    }
    return 0;
}
string fillDashes(ll n){
    string ret;
    for(ll i = 0; i < n; i++){ret += '-';}
    return ret;
}
string sub(string a, string b){
    if(cmp(a, b) == -1){return "NEGNEGNEG";}
    ll len = a.length();
    while(b.length() < len){b = '0' + b;}
    string res = fillDashes(len);
    short carry = 0;
    for(ll i = len-1; i >= 0; i--){
        short vA = a[i]-'0' - carry;
        short vB = b[i]-'0';
        short val = vA - vB;
        carry = 0;
        while(val < 0){
            val += 2;
            carry++;
        }
        res[i] = val+'0';
    }
    for(ll i = 0; i < res.size(); i++){
        if(res[i] != '0'){
            return res.substr(i);
        }
    }
    return "0";
}
string toS(ll n){
    string s;
    if(n == 0){s = "0";}
    while(n != 0){
        s += (n%2)+'0';
        n/=2;
    }
    reverse(s.begin(), s.end());
    return s;
}
psl biggestAlt(ll n){
    string sn = toS(n);
    ll lg = log2(n);
    string res = alternate(lg);
    while(cmp(res, sn) == 1){
        res = alternate(--lg);
    }
    return {res, lg};
}
ll toN(string s){
    ll res = 0;
    for(ll i = 0; i < s.length(); i++){
        if(s[i] == '1'){
            res |= (1 << (s.length()-1-i));
        }
    }
    return res;
}
psl biggestAlt(string sn){
    ll lg = log2(toN(sn));
    string res = alternate(lg);
    while(cmp(res, sn) == 1){
        res = alternate(--lg);
    }
    return {res, lg};
}
int main(){
    ll n;
    cin >> n;
    string sn = toS(n);
    unordered_set<ll> used;

    while(sn != "0"){
//        cout << "n: " << toN(sn) << '\n';
        psl bgA = biggestAlt(sn);
        while(used.count(bgA.second) != 0){
            bgA.first = alternate(bgA.second-1);
            bgA.second--;
        }
        if(bgA.second < 0){
            cout << "-1\n";
            return 0;
        }
        used.insert(bgA.second);
//        cout << "added " << bgA.second << " : " << bgA.first << '\n';
//        cout << "\tn: " << sn << " -> ";
        sn = sub(sn, bgA.first);
//        cout << sn << '\n';
    }

//    for(auto it = used.begin(); it != used.end(); ++it){
//        cout << *it << " : " << alternate(*it) << '\n';
//    }
    cout << used.size() << '\n';
    return 0;
}
