#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll mod = 998244353;
ll cnk[302][302];
ll C(ll n, ll k){
    return cnk[n+1][k+1];
}

ll na(ll a, ll b){
    ll rs = 1;
    for(ll i = 0; i < b; i++){
        rs *= a;
        rs %= mod;
    }
    return rs;
}

ll fac(ll f, ll t){
    ll acc = 1;
    for(ll i = f; i <= t; i++){
        acc *= i;
        acc %= mod;
    }
    return acc;
}

ll findTerm(int n, int m, int k, int i){
    ll vari = C(m, n+1-i) * fac(1, n+1-i);
    ll perm = fac(i+1, n);
    return (vari*perm)%mod;
}

ll solve(int n, int m, int k){
    ll init = na(m, n);
//    cout << "init: " << init << '\n';
    for(int i = k+1; i <= n; i++){
        init -= findTerm(n, m, k, i);
//        cout << "subbed " << findTerm(n, m, k, i) << " -> " << init << '\n';
    }
    return init;
}


int main(){
    cnk[0][0] = 1;
    for(ll i = 1; i < 302; i++){
        for(ll j = 1; j <= i; j++){
            cnk[i][j] = (cnk[i-1][j-1] + cnk[i-1][j]) % mod;
        }
    }

    int n, m, k;
    cin >> n >> m >> k;
    if(m < min(m, k)){ cout << "0\n"; return 0; }
    cout << solve(n, m, k) << '\n';
    return 0;
}
