#include <bits/stdc++.h>
using namespace std;

long long n;
vector<long long> binary_numbers;

void generate_binary_numbers()
{
    long long x=1, turn=1;

    while(x<=n)
    {
        binary_numbers.push_back(x);

        if(turn%2==1)
        {
            x*=2;
        }
        else
        {
            x*=2;
            x++;
        }

        turn++;
    }

    return;
}

void solve()
{
    unordered_map<long long, int> dp;
    vector<long long> v;
    v.push_back(0);

    for(int i=0; i<binary_numbers.size(); i++)
    {
        int s=v.size();

        for(int j=0; j<s; j++)
        {
            if(binary_numbers[i]+v[j]>n)
            {
                break;
            }

            long long ch=binary_numbers[i]+v[j];
            int d=dp[v[j]]+1;

            if(dp[ch]==0)
            {
                dp[ch]=d;
                v.push_back(ch);
            }
            else
            {
                dp[ch]=min(dp[ch], d);
            }
        }
    }

    if(dp[n]==0)
    {
        cout << -1;
    }
    else
    {
        cout << dp[n];
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;
    generate_binary_numbers();
    solve();

    return 0;
}

//// 1000000000000000000
