#include <bits/stdc++.h>
using namespace std;

const int MAX_N=1e5+1, MAX_Q=1e5+1;
int N, Q;
int a[MAX_N], max_a=0, min_a=1e9;
int quest[MAX_N];
int ans[MAX_Q];
unordered_map<int, int> um;

int bs(const int& x)
{
    int l=0, r=max_a;
    int m=0;
    int ans=1e9;

    while(l<=r)
    {
        m=(l+r)/2;

        if(um[m]==1)
        {
            if(m>=x)
            {
                ans=min(m-x, ans);
                r=m-1;
            }
            else
            {
                ans=min(x-m, ans);
                l=m+1;
            }
        }
        else
        {
            if(x>m)
            {
                r=m-1;
            }
            else
            {
                l=m+1;
            }
        }
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N >> Q;

    for(int i=0; i<N; i++)
    {
        cin >> a[i];
    }

    for(int i=0; i<Q; i++)
    {
        int j;
        cin >> j;
        quest[j-1]=i+1;
    }

    int mindiff=1e9;

    for(int i=0; i<N; i++)
    {
        max_a=max(max_a, a[i]);
        min_a=min(min_a, a[i]);

        if(i>1)
        {
            int curr=bs(a[i]);
            mindiff=min(mindiff, curr);
        }

        um[a[i]]=1;

        if(quest[i]!=0)
        {
            ans[quest[i]-1]=mindiff;
        }
    }

    for(int i=0; i<Q; i++)
    {
        cout << ans[i] << " ";
    }
    return 0;
}
