#include <bits/stdc++.h>

using namespace std;

const int N_max = 1e5 + 2;

int a[N_max];
int dp[N_max];

void calc(int lim)
{
    dp[0] = 0;
    dp[1] = abs(a[0] - a[1]);

    for (int i = 2; i < lim; i++)
    {
        dp[i] = INT_MAX;

        for (int q = 0; q < i; q++)
        {
            int res = abs(a[i] - a[q]);

            dp[i] = min(dp[i], res);
        }

        if (dp[i] > dp[i - 1])
        {
            dp[i] = dp[i - 1];
        }
    }

    return;
}

void solve1(int lim, int x)
{
    int res = INT_MAX;

    for (int i = 0; i < x - 1; i++)
    {
        for (int q = i + 1; q < x; q++)
        {
            res = min(res, abs(a[i] - a[q]));
        }
    }

    cout << res << endl;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    int N, Q;

    cin >> N >> Q;

    for (int i = 0; i < N; i++)
    {
        cin >> a[i];
    }

    if (Q < N)
    {
        int x;

        cin >> x;

        solve1(N, x);

        return 0;
    }

    calc(N);

    int x;

    while (Q--)
    {
        cin >> x;

        cout << dp[x - 1] << " ";
    }

    cout << endl;

    return 0;
}
