#include<iostream>

using namespace std;


int solve(unsigned long long remainder, int maxnum);
unsigned long long get_max_num(unsigned long long N);
int get_Nth_num(int N);
unsigned long long n;

int main() {
    unsigned long long n;
    cin >> n;

    cout << solve(n - get_max_num(n), 1);
    return 0;
}

int solve(unsigned long long remainder, int r) {
    unsigned long long n_rem = get_max_num(remainder);
    if(remainder == 0) {
        return r;
    } else if (n_rem == remainder) {
        return -1;
    }
    return solve(remainder - n_rem, r + 1);
}
unsigned long long get_max_num(unsigned long long N) {
    bool odd = true;
    unsigned long long i = 0;

    while ((i * 2 + odd) <= N) {

        i *= 2;
        i += odd;
        odd = !odd;

    }
    //cout << i << endl;
    return i;
}

int get_Nth_num(int N) {

    bool odd = true;
    int p = 0;
    unsigned long long i = 0;

    while (p < N) {

        i *= 2;
        i += odd;
        odd = !odd;
        p++;

    }

    return i;
}
